    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * XYIntervalDataItem.java
    029     * -----------------------
    030     * (C) Copyright 2006-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 20-Oct-2006 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data.xy;
    042
    043    import org.jfree.data.ComparableObjectItem;
    044
    045    /**
    046     * An item representing data in the form (x, x-low, x-high, y, y-low, y-high).
    047     *
    048     * @since 1.0.3
    049     */
    050    public class XYIntervalDataItem extends ComparableObjectItem {
    051
    052        /**
    053         * Creates a new instance of <code>XYIntervalItem</code>.
    054         *
    055         * @param x  the x-value.
    056         * @param xLow  the lower bound of the x-interval.
    057         * @param xHigh  the upper bound of the x-interval.
    058         * @param y  the y-value.
    059         * @param yLow  the lower bound of the y-interval.
    060         * @param yHigh  the upper bound of the y-interval.
    061         */
    062        public XYIntervalDataItem(double x, double xLow, double xHigh, double y,
    063                double yLow, double yHigh) {
    064            super(new Double(x), new XYInterval(xLow, xHigh, y, yLow, yHigh));
    065        }
    066
    067        /**
    068         * Returns the x-value.
    069         *
    070         * @return The x-value (never <code>null</code>).
    071         */
    072        public Double getX() {
    073            return (Double) getComparable();
    074        }
    075
    076        /**
    077         * Returns the y-value.
    078         *
    079         * @return The y-value.
    080         */
    081        public double getYValue() {
    082            XYInterval interval = (XYInterval) getObject();
    083            if (interval != null) {
    084                return interval.getY();
    085            }
    086            else {
    087                return Double.NaN;
    088            }
    089        }
    090
    091        /**
    092         * Returns the lower bound of the x-interval.
    093         *
    094         * @return The lower bound of the x-interval.
    095         */
    096        public double getXLowValue() {
    097            XYInterval interval = (XYInterval) getObject();
    098            if (interval != null) {
    099                return interval.getXLow();
    100            }
    101            else {
    102                return Double.NaN;
    103            }
    104        }
    105
    106        /**
    107         * Returns the upper bound of the x-interval.
    108         *
    109         * @return The upper bound of the x-interval.
    110         */
    111        public double getXHighValue() {
    112            XYInterval interval = (XYInterval) getObject();
    113            if (interval != null) {
    114                return interval.getXHigh();
    115            }
    116            else {
    117                return Double.NaN;
    118            }
    119        }
    120
    121        /**
    122         * Returns the lower bound of the y-interval.
    123         *
    124         * @return The lower bound of the y-interval.
    125         */
    126        public double getYLowValue() {
    127            XYInterval interval = (XYInterval) getObject();
    128            if (interval != null) {
    129                return interval.getYLow();
    130            }
    131            else {
    132                return Double.NaN;
    133            }
    134        }
    135
    136        /**
    137         * Returns the upper bound of the y-interval.
    138         *
    139         * @return The upper bound of the y-interval.
    140         */
    141        public double getYHighValue() {
    142            XYInterval interval = (XYInterval) getObject();
    143            if (interval != null) {
    144                return interval.getYHigh();
    145            }
    146            else {
    147                return Double.NaN;
    148            }
    149        }
    150
    151    }